__author__ = 'DarkWeb'

# Here, we are importing the auxiliary functions to clean or convert data
from MarketPlaces.Utilities.utilities import *

# Here, we are importing BeautifulSoup to search through the HTML tree
from bs4 import BeautifulSoup

import re

#parses description pages, so takes html pages of description pages using soup object, and parses it for info it needs
#stores info it needs in different lists, these lists are returned after being organized
#@param: soup object looking at html page of description page
#return: 'row' that contains a variety of lists that each hold info on the description page
def tormarket_description_parser(soup):

    # Fields to be parsed

    vendor = "-1"                       # 0 *Vendor_Name
    success = "-1"                      # 1 Vendor_Successful_Transactions
    rating_vendor = "-1"                # 2 Vendor_Rating
    name = "-1"                         # 3 *Product_Name
    describe = "-1"                     # 4 Product_Description
    CVE = "-1"                          # 5 Product_CVE_Classification (Common Vulnerabilities and Exposures)
    MS = "-1"                           # 6 Product_MS_Classification (Microsoft Security)
    category = "-1"                     # 7 Product_Category
    views = "-1"                        # 8 Product_Number_Of_Views
    reviews = "-1"                      # 9 Product_Number_Of_Reviews
    rating_item = "-1"                  # 10 Product_Rating
    addDate = "-1"                      # 11 Product_AddedDate
    BTC = "-1"                          # 12 Product_BTC_SellingPrice
    USD = "-1"                          # 13 Product_USD_SellingPrice
    EURO = "-1"                         # 14 Product_EURO_SellingPrice
    sold = "-1"                         # 15 Product_QuantitySold
    left = "-1"                         # 16 Product_QuantityLeft
    shipFrom = "-1"                     # 17 Product_ShippedFrom
    shipTo = "-1"                       # 18 Product_ShippedTo
    image = "-1"                        # 19 Product_Image
    vendor_image = "-1"                 # 20 Vendor_Image

    #finding the name of the product
    name_of_product = soup.find("h1", {"class": "product_title entry-title"}).find("a").text
    name = cleanString(name_of_product.strip())

    #finding the description of the product
    description_of_product = soup.find("div", {"class": "woocommerce-product-details__short-description"}).text
    describe = cleanString(description_of_product.strip())

    #finding the name of the vendor
    name_of_vendor = soup.find("div", {"class": "wcfmmp_sold_by_store"})
    if name_of_vendor is not None:
        name_of_vendor = name_of_vendor.find("a").text
        vendor = cleanString(name_of_vendor.strip())
    else:
        vendor = "TorMarket"

    #finding the price of the item
    price = soup.find("p", {"class": "price"}).find("bdi").text
    price_cleaned = price[1:]
    USD = price_cleaned.strip()

    category = soup.find('span', {"class": "posted_in"}).text
    category = category.split(':')[-1]
    category = category.replace(',', '/')
    category = cleanString(category.strip())
    #everything else gets a -1 because they are not found

    # Populating the final variable (this should be a list with all fields scraped)
    row = (vendor, rating_vendor, success, name, describe, CVE, MS, category, views, reviews, rating_item, addDate,
           BTC, USD, EURO, sold, left, shipFrom, shipTo, image, vendor_image)

    # Sending the results
    return row


#parses listing pages, so takes html pages of listing pages using soup object, and parses it for info it needs
#stores info it needs in different lists, these lists are returned after being organized
#@param: soup object looking at html page of listing page
#return: 'row' that contains a variety of lists that each hold info on the listing page
def tormarket_listing_parser(soup):

    # Fields to be parsed
    nm = 0                                    # *Total_Products (Should be Integer)
    mktName = "TorMarket"                     # 0 *Marketplace_Name
    vendor = []                               # 1 *Vendor y
    rating_vendor = []                        # 2 Vendor_Rating
    success = []                              # 3 Vendor_Successful_Transactions
    name = []                                 # 4 *Product_Name y
    CVE = []                                  # 5 Product_CVE_Classification (Common Vulnerabilities and Exposures) dont worry about this
    MS = []                                   # 6 Product_MS_Classification (Microsoft Security) dont worry about this
    category = []                             # 7 Product_Category y
    describe = []                             # 8 Product_Description
    views = []                                # 9 Product_Number_Of_Views
    reviews = []                              # 10 Product_Number_Of_Reviews
    rating_item = []                          # 11 Product_Rating
    addDate = []                              # 12 Product_AddDate
    BTC = []                                  # 13 Product_BTC_SellingPrice
    USD = []                                  # 14 Product_USD_SellingPrice y
    EURO = []                                 # 15 Product_EURO_SellingPrice
    sold = []                                 # 16 Product_QuantitySold
    qLeft = []                                # 17 Product_QuantityLeft
    shipFrom = []                             # 18 Product_ShippedFrom
    shipTo = []                               # 19 Product_ShippedTo
    image = []                                # 20 Product_Image
    image_vendor = []                         # 21 Vendor_Image
    href = []                                 # 22 Product_Links

    products_list = soup.find('ul', {"class": "products columns-3 tablet-columns-2 mobile-columns-1"}).find_all('li')
    nm = len(products_list)

    for product in products_list:
        # Finding the name of the product
        name_of_product = product.find("h2", {"class": "woocommerce-loop-product__title"}).find("a").text
        name_of_product_cleaned = cleanString(name_of_product.strip())
        # print(name_of_product_cleaned)
        name.append(name_of_product_cleaned)
        #finding the URL
        try:
            url = product.find("div", {"class": "product-loop-content text-center"}).find("a").get("href")
            # print(url)
            href.append(url)
        except AttributeError as e:
            print("I can't find the link")
            raise e

        #finding the rating of the product
        rating_score_of_product = product.find("div", {"class": "product-loop-content text-center"}).find("div").find("span").text
        rating_item.append(cleanString(rating_score_of_product.strip()))
        # print("done")
        #finding the rating of the vendors
        rating_score_of_vendor = product.find("div", {"class": "wcfmmp-store-rating"})
        if rating_score_of_vendor is not None:
            rating_score_of_vendor = rating_score_of_vendor.find("strong").text
            rating_vendor.append(cleanString(rating_score_of_vendor.strip()))
        else:
            rating_vendor.append('-1')
        # print("done")
        #finding the cost in USD
        cost = product.find("span", {"class": "woocommerce-Price-amount amount"}).text
        USD.append(cost)
        # print("done")
        #finding the name of the vendor
        vendor_name = product.find("div", {"class": "wcfmmp_sold_by_wrapper"})
        if vendor_name is not None:
            vendor_name = vendor_name.find("a").text
            vendor.append(cleanString(vendor_name.strip()))
        else:
            vendor.append(mktName)
        # print("done")
        #everything else appends a -1
        success.append("-1")
        CVE.append("-1")
        MS.append("-1")
        category.append("-1")
        describe.append("-1")
        views.append("-1")
        reviews.append("-1")
        addDate.append("-1")
        BTC.append("-1")
        EURO.append("-1")
        sold.append("-1")
        qLeft.append("-1")
        shipFrom.append("-1")
        shipTo.append("-1")
        # print("Done! moving onto the next product!")
        # print(len(shipTo))


    # Populate the final variable (this should be a list with all fields scraped)
    return organizeProducts(mktName, nm, vendor, rating_vendor, success, name, CVE, MS, category, describe, views,
                            reviews, rating_item, addDate, BTC, USD, EURO, sold, qLeft, shipFrom, shipTo, href, image, image_vendor)


#called by the crawler to get description links on a listing page
#@param: beautifulsoup object that is using the correct html page (listing page)
#return: list of description links from a listing page
def tormarket_links_parser(soup):

    # Returning all links that should be visited by the Crawler

    href = []
    listing = soup.findAll('div', {"class": "product-loop-content text-center"})

    for a in listing:
        bae = a.find('h2', {"class": "woocommerce-loop-product__title"}).find('a', href=True)
        link = bae['href']
        href.append(link)

    return href